import time

# global current state of the backtrack
numberOfEachCoinType = []
numberOfCoinsSoFar = 0
solutionFound = False
bestFewestCoins = -1
bestNumberOfEachCoinType = None

# profiling
backtrackingNodes = 0

def main():
    changeAmt = int(raw_input("Enter the change amount: "))
    coinTypes = raw_input("Enter the coin types separated by spaces: ")
    coinTypes = coinTypes.split(" ")
    for index in xrange(len(coinTypes)):
        coinTypes[index] = int(coinTypes[index])
    print "Change Amount:",changeAmt,"   Coin types:", coinTypes
    start = time.clock()
    fewestCoins, numberOfEachCoinType = solveCoinChange(changeAmt, coinTypes)
    end = time.clock()
    print "Run-time: %.3f seconds" % (end - start)
    print "Fewest number of coins",fewestCoins
    print "The number of each type of coin in the solution is:"
    for index in xrange(len(coinTypes)):
        print "number of %s-cent coins is %s"%(str(coinTypes[index]),
                                              str(numberOfEachCoinType[index]))
    return

def solveCoinChange(changeAmt, coinTypes):

    def backtrack(changeAmt):
        global numberOfEachCoinType
        global numberOfCoinsSoFar
        global solutionFound
        global bestFewestCoins
        global bestNumberOfEachCoinType
        global backtrackingNodes
        backtrackingNodes += 1

        for index in range(len(coinTypes)):
            smallerChangeAmt = changeAmt - coinTypes[index]
            if promising(smallerChangeAmt, numberOfCoinsSoFar+1):
                if smallerChangeAmt == 0:  # a solution is found
                    if (not solutionFound) or numberOfCoinsSoFar + 1 < bestFewestCoins: # check if its best
                        bestFewestCoins = numberOfCoinsSoFar+1
                        bestNumberOfEachCoinType = [] + numberOfEachCoinType
                        bestNumberOfEachCoinType[index] += 1
                        solutionFound = True
                else:
                    # update global "current state" for child before call
                    numberOfCoinsSoFar += 1
                    numberOfEachCoinType[index] += 1
                    
                    backtrack(smallerChangeAmt)
                    
                    # undo change to global "current state" after backtracking
                    numberOfCoinsSoFar -= 1
                    numberOfEachCoinType[index] -= 1
    # end def backtrack


    def promising(changeAmt, numberOfCoinsReturned):
        if changeAmt < 0:
            return False
        elif changeAmt == 0:
            return True
        else:  # changeAmt > 0
            if solutionFound and numberOfCoinsReturned+1 >= bestFewestCoins:
                return False
            else:
                return True

    # set-up initial "current state" information
    global numberOfEachCoinType
    global numberOfCoinsSoFar
    global solutionFound
    global bestFewestCoins
    global bestNumberOfEachCoinType

    numberOfEachCoinType = []
    for coin in coinTypes:
        numberOfEachCoinType.append(0)
    numberOfCoinsSoFar = 0
    solutionFound = False
    bestFewestCoins = -1
    bestNumberOfEachCoinType = None
    
    backtrack(changeAmt)
    return bestFewestCoins, bestNumberOfEachCoinType

main()
print "Number of Backtracking Nodes:", backtrackingNodes
raw_input("hit <Enter> to end")
